<?php
  function tep_mobile_link($page = '', $parameters = '', $connection = 'NONSSL', $add_session_id = true, $search_engine_safe = true ) {
	return tep_href_link($page, $parameters, $connection, $add_session_id, $search_engine_safe);  	
  }

/*
Function tep_button_jquery
 $option :
 data-inline="true/false" -> button on same line
 data-rel="back" -> create a back button 
 data-icon="plus" -> more info at http://view.jquerymobile.com/1.3.1/dist/demos/widgets/icons/

 $role :
 button -> For link
 submit -> For Post or Get

 $transition -> Edit this option in back office
 More info at http://view.jquerymobile.com/1.3.1/dist/demos/widgets/transitions/
*/  

function tep_button_jquery($text, $link, $theme = 'a', $role = 'button', $option = '' ) {

  if( MOBILE_SITE_TRANSITION != 'False'  )
    $transition = 'data-transition="'.MOBILE_SITE_TRANSITION.'"';

  if( $role == 'button' ) {
    $button = '<a data-theme="'.$theme.'"  '.$option.' '.$transition.' href="'.$link.'" data-role="'.$role.'">'.$text.'</a>';
  } else if( $role == 'submit' ) {
    $button =  '<input value="'.$text.'" type="'.$role.'" data-role="'.$role.'"  data-theme="'.$theme.'" '.$option.' '.$transition.' >';
  } else {
    $button = '<a data-theme="'.$theme.'"  '.$option.' '.$transition.' href="'.$link.'" >'.$text.'</a>'; 
  }
        
return $button;
}


/*
Function tep_checkbox_jquery
 $option :
 data-inline="true/false" -> button on same line
 data-mini="true/false" -> small/normal button size
 Changes to be made :
 --> use array for name id value
*/  
  function tep_checkbox_jquery($name, $checked, $theme = 'a', $value = '' , $option = '' ) {
	
    if ( $checked == true || (isset($_GET[$name]) && $_GET[$name] == true) || (isset($_POST[$name]) && $_POST[$name] == true) )
        $checked = 'checked'; 
	
    $button = '<input name="'.$name.'" id="'.$name.'" '.$checked.' value="'.$value.'" type="checkbox" data-theme="'.$theme.'" '.$option.'>';

  return $button;
  }

/*
Function tep_label_input_jquery
 $parameters :
 data-mini="true/false" -> small/normal field size

 &label :
 if $placeholder = false: field label shows before field
 if $placeholder = true: field label shows in field
 
 $type : 
 "text", "number", "tel", "email", "url", "password"  -> enables specific input on mobile devices
 
 $placeholder :
 "true/false" -> overwrites configuration setting in admin

 $clearbutton : 
 "true/false" -> overwrites configuration setting in admin 

 $id : 
 "true/false" -> use if id is different from name 
 */
function tep_label_input_jquery($name, $value = '', $label = '', $theme = 'a', $parameters = '', $type = 'text', $reinsert_value = true, $placeholder = '', $clearbutton = '', $id = '' ) {

   if (empty($placeholder)) $placeholder =  MOBILE_PLACEHOLDER;
   if (empty($clearbutton)) $clearbutton =  MOBILE_CLEARBUTTON;
   if (tep_not_null($label) && $placeholder != 'true') $field =  '<label for="' . $name . '" >' . $label . '</label>';

   $field .= '<input data-theme="'.$theme.'" type="' . tep_output_string($type) . '" name="' . tep_output_string($name) . '"';

   if (tep_not_null($id)) {
     $field .= ' id="' . tep_output_string($id) . '"';
   } else {
     $field .= ' id="' . tep_output_string($name) . '"';
   }    
    
   if ( ($reinsert_value == true) && ( (isset($_GET[$name]) && is_string($_GET[$name])) || (isset($_POST[$name]) && is_string($_POST[$name])) ) ) {
      if (isset($_GET[$name]) && is_string($_GET[$name])) {
        $value = stripslashes($_GET[$name]);
      } elseif (isset($_POST[$name]) && is_string($_POST[$name])) {
        $value = stripslashes($_POST[$name]);
      }
    }

    if (tep_not_null($value)) {
      $field .= ' value="' . tep_output_string($value) . '"';
    }

    if (tep_not_null($label) && $placeholder == 'true') $field .= ' placeholder="' . strip_tags($label) . '"';
    if ($clearbutton == 'true') $field .= ' data-clear-btn="true"';

    if (tep_not_null($parameters)) $field .= ' ' . $parameters;

    $field .= '>';

    return $field;
  }
  
/*
Function tep_input_jquery
Replaced by "Function tep_label_input_jquery" - Maintained for compatibility
 $option :
 data-inline="true/false" -> button on same line

 Changes to be made :
 --> only a copy of tep_draw_input_field just add id
*/  
function tep_input_jquery($name, $value = '', $parameters = '', $type = 'text', $reinsert_value = true) {

    $field = '<input data-theme="a" type="' . tep_output_string($type) . '" id="'.tep_output_string($name).'" name="' . tep_output_string($name) . '"';

    if ( ($reinsert_value == true) && ( (isset($_GET[$name]) && is_string($_GET[$name])) || (isset($_POST[$name]) && is_string($_POST[$name])) ) ) {
      if (isset($_GET[$name]) && is_string($_GET[$name])) {
        $value = stripslashes($_GET[$name]);
      } elseif (isset($_POST[$name]) && is_string($_POST[$name])) {
        $value = stripslashes($_POST[$name]);
      }
    }

    if (tep_not_null($value)) {
      $field .= ' value="' . tep_output_string($value) . '"';
    }

    if (tep_not_null($parameters)) $field .= ' ' . $parameters;

    $field .= '>';

    return $field;
  }

/*

Function tep_input_search_jquery

 $option :
 data-inline="true/false" -> button or input on same line

 Changes to be made :
 --> only a copy of tep_draw_input_field just add id, parameters is use for search text

*/  
function tep_input_search_jquery($name, $value = '', $parameters = INPUT_SEARCH, $type = 'text', $reinsert_value = true) {

    $field = '<input data-theme="a" type="' . tep_output_string($type) . '" placeholder="'.$parameters.'" id="'.tep_output_string($name).'" name="' . tep_output_string($name) . '"';

    if ( ($reinsert_value == true) && ( (isset($_GET[$name]) && is_string($_GET[$name])) || (isset($_POST[$name]) && is_string($_POST[$name])) ) ) {
      if (isset($_GET[$name]) && is_string($_GET[$name])) {
        $value = stripslashes($_GET[$name]);
      } elseif (isset($_POST[$name]) && is_string($_POST[$name])) {
        $value = stripslashes($_POST[$name]);
      }
    }

    if (tep_not_null($value)) {
      $field .= ' value="' . tep_output_string($value) . '"';
    }

    $field .= '>';

    return $field;
  }

////
// Output a form password field
  function tep_label_password_jquery ($name, $value = '', $label = '', $theme = 'a', $parameters = 'maxlength="40" autocomplete="off"', $placeholder = '', $clearbutton = '' ) {

    return tep_label_input_jquery($name, $value, $label, $theme, $parameters, 'password', false, $placeholder, $clearbutton);

  }

////
//function tep_radio_jquery
function tep_radio_jquery($name, $checked, $theme = 'a', $value = '' , $option = '' ) {
	
  if( $checked == true ) {
    $checked = 'checked'; 
  } else {
    $checked = '';
  }
  $button = '<input name="'.$name.'" '.$option.' '.$checked.' value="'.$value.'" type="radio" data-theme="'.$theme.'" >';

return $button;
}

/*
function tep_label_textarea_jquery
 $parameters :
 data-mini="true/false" -> small/normal field size

 &label :
 if $placeholder = false: field label shows before field
 if $placeholder = true: field label shows in field

 &width :
 textarea width in px or em (unit needs to be added)
 &height :
 textarea height in px or em (unit needs to be added)
 
 $placeholder :
 "true/false" -> overwrites configuration setting in admin

 $id : 
 "true/false" -> use if id is different from name 
 */
  function tep_label_textarea_jquery($name, $label = '', $width, $height, $text = '', $theme = 'a', $parameters = '', $reinsert_value = true, $placeholder = '', $id = '' ) {

    if ($placeholder == '') $placeholder =  MOBILE_PLACEHOLDER;
    if (tep_not_null($label) && $placeholder != true) $field =  '<label for="' . $name . '" >' . $label . '</label>';

    $field .= '<textarea name="' . tep_output_string($name) . '"';

    if (tep_not_null($id)) {
      $field .= ' id="' . tep_output_string($id) . '"';
    } else {
      $field .= ' id="' . tep_output_string($name) . '"';
    }    

    if ( tep_not_null($width) || tep_not_null($height) ) $field .= ' style="';
    if ( tep_not_null($width) ) $field .= ' width:' . $width . ';';
    if ( tep_not_null($height) ) $field .= ' height:' . $height . ';';
    if ( tep_not_null($width) || tep_not_null($height) ) $field .= '" ';

    if (tep_not_null($parameters)) $field .= ' ' . $parameters;

    if (tep_not_null($label) && $placeholder == true) $field .= 'placeholder="' . strip_tags($label) . '"';

    $field .= ' data-theme="'.$theme.'" >';

    if ( ($reinsert_value == true) && ( (isset($_GET[$name]) && is_string($_GET[$name])) || (isset($_POST[$name]) && is_string($_POST[$name])) ) ) {
      if (isset($_GET[$name]) && is_string($_GET[$name])) {
        $field .= tep_output_string_protected(stripslashes($_GET[$name]));
      } elseif (isset($_POST[$name]) && is_string($_POST[$name])) {
        $field .= tep_output_string_protected(stripslashes($_POST[$name]));
      }
    } elseif (tep_not_null($text)) {
      $field .= tep_output_string_protected($text);
    }

    $field .= '</textarea>';

    return $field;
  }
  
/*
Output a labeled jquery form pull down menu
 $parameters :
 data-inline="true/false" -> fields on same line
 data-mini="true/false" -> small/normal field size

 &label :
 if $placeholder = false: field label shows before field
 if $placeholder = true: field label shows as default option: "Please select "$label"

 $defaultlabel: 
 If used overwrites the default option

 $placeholder :
 "true/false" -> overwrites configuration setting in admin

 $nativemenu : 
 "true/false" -> overwrites configuration setting in admin 

 $id : 
 "true/false" -> use if id is different from name 
 */
  function tep_label_pull_down_menu_jquery($name, $values, $label = '', $defaultlabel = '', $default = '', $theme = 'a', $parameters = '', $required = false, $placeholder = '', $nativemenu = '', $id = '' ) {

    if (empty($placeholder)) $placeholder =  MOBILE_PLACEHOLDER_MENU;
    if (empty($nativemenu)) $nativemenu =  MOBILE_NATIVEMENU;
    if (empty($defaultlabel)) {
      if (tep_not_null($label) && $placeholder == 'true') {
        $valuesdef[0] = array('id' => false,
	  		    'text' => MOBILE_PULL_DOWN_DEFAULT_1  . '&nbsp;' . strip_tags(str_replace(':', '', $label)) . '&nbsp;' . MOBILE_PULL_DOWN_DEFAULT_2);   
      } else {
        $valuesdef[0] = array('id' => false,
			    'text' => MOBILE_PULL_DOWN_DEFAULT_1  . '&nbsp;' . MOBILE_PULL_DOWN_DEFAULT_2);        
      } 	    
    } else {
      $valuesdef[0] = array('id' => false,
			  'text' => $defaultlabel);        	    
    } 	    
    if ( (isset($valuesdef)) && (tep_not_null($valuesdef)) ) 
      $values = array_merge($valuesdef, $values);

    if (tep_not_null($label) && $placeholder != 'true') $field =  '<label>' . $label . '</label>';
      $field .= '<select name="' . tep_output_string($name) . '"';

    if (tep_not_null($id)) {
      $field .= ' id="' . tep_output_string($id) . '"';
    } else {
      $field .= ' id="' . tep_output_string($name) . '"';
    }    

    if (tep_not_null($parameters)) $field .= ' ' . $parameters;
    $field .= ' data-theme="'.$theme . '"';
    if ($nativemenu != 'true') $field .= ' data-native-menu="false"';
    $field .= '>';

    if (empty($default) && ( (isset($_GET[$name]) && is_string($_GET[$name])) || (isset($_POST[$name]) && is_string($_POST[$name])) ) ) {
      if (isset($_GET[$name]) && is_string($_GET[$name])) {
        $default = stripslashes($_GET[$name]);
      } elseif (isset($_POST[$name]) && is_string($_POST[$name])) {
        $default = stripslashes($_POST[$name]);
      }
    }

    for ($i=0, $n=sizeof($values); $i<$n; $i++) {
      $field .= '<option value="' . tep_output_string($values[$i]['id']) . '"';
      if ($default == $values[$i]['id']) {
        $field .= ' selected="selected"';
      }

      $field .= '>' . tep_output_string($values[$i]['text'], array('"' => '&quot;', '\'' => '&#039;', '<' => '&lt;', '>' => '&gt;')) . '</option>';
    }
    $field .= '</select>';

    return $field;
  }

/*
Output a jquery pull-down list of countries
 $parameters :
 data-inline="true/false" -> fields on same line
 data-mini="true/false" -> small/normal field size

 &label :
 if $placeholder = false: field label shows before field
 if $placeholder = true: field label shows as default option: "Please select "$label"

 $defaultlabel: 
 If used overwrites the default option

 $placeholder :
 "true/false" -> overwrites configuration setting in admin

 $nativemenu : 
 "true/false" -> overwrites configuration setting in admin 
 */
  function tep_label_get_country_list_jquery($name, $selected = '', $label = '', $defaultlabel, $theme = 'a', $parameters = '', $required = false, $placeholder = '', $nativemenu = '' ) {
    
    $countries_array = array(array('id' => '', 'text' => strip_tags(MOBILE_PULL_DOWN_DEFAULT_1 . '&nbsp;' . str_replace(':', '', $label) . '&nbsp;' . MOBILE_PULL_DOWN_DEFAULT_2)));
    $countries = tep_get_countries();
    
    if (empty($default) && ( (isset($_GET[$name]) && is_string($_GET[$name])) || (isset($_POST[$name]) && is_string($_POST[$name])) ) ) {
      if (isset($_GET[$name]) && is_string($_GET[$name])) {
        $selected = stripslashes($_GET[$name]);
      } elseif (isset($_POST[$name]) && is_string($_POST[$name])) {
        $selected = stripslashes($_POST[$name]);
      }
    }

    for ($i=0, $n=sizeof($countries); $i<$n; $i++) {
      $countries_array[] = array('id' => $countries[$i]['countries_id'], 'text' => $countries[$i]['countries_name']);
    }

    return tep_label_pull_down_menu_jquery($name, $countries_array, $label, '', $selected, $theme, $parameters, $required, $placeholder, $nativemenu);
  }
  
  
/*
Output a pop up jquery menu
 $parameters :
 data-inline="true/false" -> fields on same line
 data-mini="true/false" -> small/normal field size

 &label :
 if $placeholder = false: field label shows before field
 if $placeholder = true: field label shows as default option: "Please select "$label"

 $defaultlabel: 
 If used overwrites the default option

 $variable:
 html variable addet to url: "manufacturers_id"
 
 $placeholder :
 "true/false" -> overwrites configuration setting in admin
 */
  function tep_pop_up_menu_jquery($name, $values, $label = '', $defaultlabel = '', $variable = '', $theme = 'a', $parameters = '', $placeholder = '' ) {
    global $PHP_SELF;

    if (empty($placeholder)) $placeholder =  MOBILE_PLACEHOLDER_POPUP;
    if (tep_not_null($label) && $placeholder == 'true') {
      $buttonlabel = strip_tags(MOBILE_PULL_DOWN_DEFAULT_1 . '&nbsp;' . $label . '&nbsp;' . MOBILE_PULL_DOWN_DEFAULT_2);   
    } elseif (!empty($defaultlabel)) {
      $buttonlabel = $defaultlabel;        
    } 	    

    if (tep_not_null($label) && $placeholder != 'true') $field =  '<label for="' . $name . '" >' . $label . '</label>';

    $field .= '<a href="#' . $name . '" data-rel="popup" data-role="button" data-transition="slideup" data-theme="'.$theme.'" data-icon="arrow-d" data-iconpos="right">';
    if (tep_not_null($parameters)) $field .= ' ' . $parameters;
    $field .= $buttonlabel . '</a>' .
              '<div data-role="popup" id="' . $name . '" data-theme="'.$theme.'">' .
              '  <ul data-role="listview" data-inset="true" style="min-width:210px;" data-theme="'.$theme.'">';

    foreach ($values as $item ) {
      if (isset($_GET[$variable]) && $_GET[$variable] == $item['id']) {
        $icon = 'check';
        $dataThemeList = 'b';
        $manulabel = $item['text'];
      } else {
        $icon = 'arrow-r';
        $dataThemeList = 'a';
      }
      
      $path = tep_mobile_link(basename($PHP_SELF), tep_get_all_get_params(array($variable)) . $variable . '=' . $item['id']); 
      $fieldValues .= '<li data-theme="' . $dataThemeList . '" data-icon="' . $icon . '" data-iconpos="right"><a href="' . $path . '">' . tep_output_string($item['text']) . '</a></li>';
    }


    $field .= $fieldValues;
    $field .= '  </ul>' . 
       	      '</div>';

    return $field;
  }

////
// Creates jquery radio select buttons for gender	
  function tep_radio_select_gender_jquery($name = 'gender', $legend, $theme = 'a', $selectedGender ='', $parameters = ''){

      $mselected = false;
      $fselected = false;

      if (isset($_POST[$name]) && $_POST[$name] == 'm' || $selectedGender == 'm') {
        $mselected = true;
      } elseif (isset($_POST[$name]) && $_POST[$name] == 'f' || $selectedGender == 'f') {
        $fselected = true;
      }
    
    $field='';
    if (tep_not_null($legend)) {
      $field =  '<div class="ui-grid-a ui-responsive">';

      $field .= '  <div class="ui-block-a" style="width:170px; position:relative; top:0.3em">' . $legend . '</div>';
    }
      $field .= '  <div class="ui-block-b">
      		     <fieldset data-role="controlgroup" id="custom-fieldset" data-type="horizontal">';
      		    
      $field .= '      <label for="m">' . MALE . '</label>' . tep_radio_jquery($name, $mselected, $theme, 'm', 'id="m" ' . $parameters) . 
                '      <label for="f">' . FEMALE . '</label>' . tep_radio_jquery($name, $fselected, $theme, 'f', 'id="f" ' . $parameters);
    
      $field .= '    </fieldset>
                   </div>
                 </div>';
    
      return $field ;
  }

/* Creates a pull-down list for date of birth
 $parameters :
 data-inline="true/false" -> fields on same line
 data-mini="true/false" -> small/normal field size

 $day, $month, $year :
 default options
 
 &label :
 if $placeholder = false: field label shows before field
 if $placeholder = true: field label shows as default option: "Please select "$label"

 $defaultlabel: 
 If used overwrites the default option

 $starty :
 first year to show
 
 $placeholder :
 "true/false" -> overwrites configuration setting in admin

 $nativemenu : 
 "true/false" -> overwrites configuration setting in admin 
 */

  function tep_draw_pull_down_date_jquery($name='date', $day='', $month='', $year='', $label = '', $defaultlabel = '', $default = '', $theme = 'a', $parameters = '', $full=false, $mnth=false, $starty='', $nativemenu = ''){
    global $PHP_SELF;

      if (isset($_GET['dob_inY']) && is_numeric($_GET['dob_inY'])) {
        $year = stripslashes($_GET['dob_inY']);
      } elseif (isset($_POST['dob_inY']) && is_numeric($_POST['dob_inY'])) {
        $year = stripslashes($_POST['dob_inY']);
      }
    
    if ($day=='') $day=date('d');
    if ($month=='') $month=date('m');
    if ($year=='') $year=date('Y');
    $endy=date('Y')-8;
    if ($starty=='') $starty=date('Y')-1;$endy=date('Y')+2;
    $named = $name . 'd';
    $namem = $name . 'm';
    $namey = $name . 'Y';
    // Array for days
    $days=array();
    for($i=1; $i<=31; $i++){
      if(strlen($i)!= 2){
        $j = '0' . $i;
      } else {
        $j = $i;
      } 
    $days[] = array('id' => $j, 'text' => $j); }

    if ($mnth) {
      $months = array(array('id' => '01', 'text' => MOBILE_DATE_JAN),
      	        array('id' => '02', 'text' => MOBILE_DATE_FEB),
      	        array('id' => '03', 'text' => MOBILE_DATE_MAR),
      	        array('id' => '04', 'text' => MOBILE_DATE_APR),
      	        array('id' => '05', 'text' => MOBILE_DATE_MAY),
      	        array('id' => '06', 'text' => MOBILE_DATE_JUN),
      	        array('id' => '07', 'text' => MOBILE_DATE_JUL),
      	        array('id' => '08', 'text' => MOBILE_DATE_AUG),
      	        array('id' => '09', 'text' => MOBILE_DATE_SEP),
      	        array('id' => '10', 'text' => MOBILE_DATE_OCT),
      	        array('id' => '11', 'text' => MOBILE_DATE_NOV),
      	        array('id' => '12', 'text' => MOBILE_DATE_DEC));
    } else {
      for($i=1; $i<=12; $i++){
        if(strlen($i)!= 2){
          $j = '0' . $i;
        } else {
          $j = $i;
        } 
    $months[] = array('id' => $j, 'text' => $j); }}

    for($i=$starty; $i<=$endy; $i++){
      $j = $i;
      if ($full) {
        $y = $i - 2000;
        if(strlen($y)!= 2){
          $j = '0' . $y;
        } else {
          $j = $y;
        }
      }
    $years[] = array('id' => $i, 'text' => $j); }
    $field='';
    if (tep_not_null($label)) {
      $field = '<div class="ui-grid-a ui-responsive">';

      $field .='  <div class="ui-block-a" style="width:170px; position:relative; top:0.3em">' . $label . '</div>';
    }
      $field .='  <div class="ui-block-b">
      		    <fieldset data-role="controlgroup" data-type="horizontal">';

    switch (DATE_FORMAT) {
      case 'd/m/Y':
        $field .= tep_label_pull_down_menu_jquery($named, $days, '', MOBILE_DATE_DAY, $day, 'a', 'data-inline="true" data-mini="true"', false, false);
        $field .= tep_label_pull_down_menu_jquery($namem, $months, '', MOBILE_DATE_MONTH, $month, 'a', 'data-inline="true" data-mini="true"', false, false);
        $field .= tep_label_pull_down_menu_jquery($namey, $years, '', MOBILE_DATE_YEAR, $year, 'a', 'data-inline="true" data-mini="true"', false, false);
        break;
      case 'm/d/Y':
        $field .= tep_label_pull_down_menu_jquery($named, $months, '', MOBILE_DATE_MONTH, $month, 'a', 'data-inline="true" data-mini="true"', false, false);
        $field .= tep_label_pull_down_menu_jquery($namem, $days, '', MOBILE_DATE_DAY, $day, 'a', 'data-inline="true" data-mini="true"', false, false);
        $field .= tep_label_pull_down_menu_jquery($namey, $years, '', MOBILE_DATE_YEAR, $year, 'a', 'data-inline="true" data-mini="true"', false, false);
        break;
      case 'Y/m/d':
        $field .= tep_label_pull_down_menu_jquery($named, $years, '', MOBILE_DATE_YEAR, $year, 'a', 'data-inline="true" data-mini="true"', false, false);
        $field .= tep_label_pull_down_menu_jquery($namem, $months, '', MOBILE_DATE_MONTH, $month, 'a', 'data-inline="true" data-mini="true"', false, false);
        $field .= tep_label_pull_down_menu_jquery($namey, $days, '', MOBILE_DATE_DAY, $day, 'a', 'data-inline="true" data-mini="true"', false, false);
        break;
      default:
        $field .= tep_label_pull_down_menu_jquery($named, $days, '', MOBILE_DATE_DAY, $day, 'a', 'data-inline="true" data-mini="true"', false, false);
        $field .= tep_label_pull_down_menu_jquery($namem, $months, '', MOBILE_DATE_MONTH, $month, 'a', 'data-inline="true" data-mini="true"', false, false);
        $field .= tep_label_pull_down_menu_jquery($namey, $years, '', MOBILE_DATE_YEAR, $year, 'a', 'data-inline="true" data-mini="true"', false, false);
        break;
    }
    
      $field .=  '    </fieldset>
                    </div>
                  </div>';
    
      return $field ;
  }
   
// Country-State Selector - zone update function
	function tep_ajax_get_zones_html($country, $default_zone = '', $ajax_output = true) {
		$output = '';

		$zones_array = array();    
		$zones_query = tep_db_query("select zone_id, zone_name from " . TABLE_ZONES . " where zone_country_id = '" . (int)$country . "' order by zone_name");
		while ($zones_values = tep_db_fetch_array($zones_query)) {
			$zones_array[] = array('id' => $zones_values['zone_id'], 'text' => $zones_values['zone_name']);
		}

		if ( tep_db_num_rows($zones_query) ) {
			$output .= tep_label_pull_down_menu_jquery('zone_id', $zones_array, ENTRY_STATE . (tep_not_null(ENTRY_STATE_TEXT)? '<span class="inputRequirement">&nbsp;' . ENTRY_STATE_TEXT . '</span>': ''), '', $default_zone, 'a', 'data-mini="true"');
		} else {
			$output .= tep_label_input_jquery('state', $default_zone, ENTRY_STATE . (tep_not_null(ENTRY_STATE_TEXT)? '<span class="inputRequirement">&nbsp;' . ENTRY_STATE_TEXT . '</span>': ''));
		}  
		
		if ($ajax_output) {
		  if (CHARSET == 'utf-8') {
		  	  header('Content-type: text/html; charset=utf-8');
		  } else {
		  	  header('Content-type: text/html; ' . MOBILE_CHARSET);
		  }
		  echo $output;
		} else {
			return $output;
		}
	}

////
// Return pop up menu with sorting capabilities
  function tep_create_sort_menu($sortby, $colnum, $heading ) {
    global $PHP_SELF;

    $sort_link = '';
    $sort_button = '';
    $sort_icon = '';

    if ($sortby) {
      $sort_link = tep_href_link(basename($PHP_SELF), tep_get_all_get_params(array('page', 'info', 'sort')) . 'page=1&sort=' . $colnum . ($sortby == $colnum . 'a' ? 'd' : 'a'));
      $sort_icon = (substr($sortby, 0, 1) == $colnum ? (substr($sortby, 1, 1) == 'a' ? 'arrow-d' : 'arrow-u') : 'arrow-u');
      $sort_style = (substr($sortby, 0, 1) == $colnum ? 'a' : 'b');
      $sort_menu = '<li data-theme="' . $sort_style . '" data-icon="' . $sort_icon . '" data-iconpos="right"><a href="' . $sort_link . '">' . TEXT_SORT_BY . $heading . '</a></li>';
    }

    return $sort_menu;
  }
  
  
////
// category menu in new_products and specials
  function tep_get_categories_ids($parent_id = '0') {
    global $languages_id;

    if (!isset($categories_ids)) $categories_ids = "";

    $categories_query = tep_db_query("select c.categories_id, cd.categories_name from " . TABLE_CATEGORIES . " c, " . TABLE_CATEGORIES_DESCRIPTION . " cd where parent_id = '" . (int)$parent_id . "' and c.categories_id = cd.categories_id and cd.language_id = '" . (int)$languages_id . "' order by sort_order, cd.categories_name");
    while ($categories = tep_db_fetch_array($categories_query)) {
      	$categories_ids .= $categories['categories_id'].",";
		
      if ($categories['categories_id'] != $parent_id) {
        $categories_ids .= tep_get_categories_ids($categories['categories_id']);
      }
    }

    return $categories_ids;
  }

////
// copy of tep_get_categories function
// html tags stripped from category names and category selection for selected manufacturers in new_products and specials
  function tep_get_categories_mobile($categories_array = '', $parent_id = '0', $indent = '') {
    global $languages_id;

    if (!is_array($categories_array)) $categories_array = array();
    
    if (isset($_GET['manufacturers_id']) && !empty($_GET['manufacturers_id'])) { //manufacturer is selected
      $categories_sql = "select distinct c.categories_id, cd.categories_name from " . TABLE_PRODUCTS . " p, " . TABLE_PRODUCTS_TO_CATEGORIES . " p2c, " . TABLE_CATEGORIES . " c, " . TABLE_CATEGORIES_DESCRIPTION . " cd where p.products_status = '1' and p.products_id = p2c.products_id and p2c.categories_id = c.categories_id and p2c.categories_id = cd.categories_id and cd.language_id = '" . (int)$languages_id . "' and p.manufacturers_id = '" . (int)$_GET['manufacturers_id'] . "' order by cd.categories_name";
      $categories_query = tep_db_query($categories_sql);
      $categories_array = array(array('id' => '', 'text' => TEXT_ALL_CATEGORIES));
      while ($categories = tep_db_fetch_array($categories_query)) {
        $categories_name  =  strip_tags($categories['categories_name']);
      	$categories_array[] = array('id' => $categories['categories_id'], 
      			          'text' => $categories_name);
      }
    } else { //show all categories
      $categories_query = tep_db_query("select c.categories_id, cd.categories_name from " . TABLE_CATEGORIES . " c, " . TABLE_CATEGORIES_DESCRIPTION . " cd where parent_id = '" . (int)$parent_id . "' and c.categories_id = cd.categories_id and cd.language_id = '" . (int)$languages_id . "' order by sort_order, cd.categories_name");
      while ($categories = tep_db_fetch_array($categories_query)) {
        $categories_name  =  strip_tags($categories['categories_name']);
        $categories_array[] = array('id' => $categories['categories_id'],
                                  'text' => $indent . $categories_name);

        if ($categories['categories_id'] != $parent_id) {
          $categories_array = tep_get_categories_mobile($categories_array, $categories['categories_id'], $indent . '&nbsp;&nbsp;');
        }
      }
    }
    return $categories_array;
  }
?>
