<?php
require_once('includes/application_top.php');
global $request_type;

    $define_list = array('PRODUCT_LIST_MODEL' => MOBILE_PRODUCT_LIST_MODEL,
                         'PRODUCT_LIST_NAME' => MOBILE_PRODUCT_LIST_NAME,
                         'PRODUCT_LIST_MANUFACTURER' => MOBILE_PRODUCT_LIST_MANUFACTURER,
                         'PRODUCT_LIST_PRICE' => MOBILE_PRODUCT_LIST_PRICE,
                         'PRODUCT_LIST_QUANTITY' => MOBILE_PRODUCT_LIST_QUANTITY,
                         'PRODUCT_LIST_WEIGHT' => MOBILE_PRODUCT_LIST_WEIGHT,
                         'PRODUCT_LIST_IMAGE' => MOBILE_PRODUCT_LIST_IMAGE,
                         'PRODUCT_LIST_BUY_NOW' => MOBILE_PRODUCT_LIST_BUY_NOW);

    asort($define_list);

    $column_list = array();
    reset($define_list);
    while (list($key, $value) = each($define_list)) {
      if ($value > 0) $column_list[] = $key;
    }

    $select_column_list = '';

    for ($i=0, $n=sizeof($column_list); $i<$n; $i++) {
      switch ($column_list[$i]) {
        case 'PRODUCT_LIST_MODEL':
          $select_column_list .= 'p.products_model, ';
          break;
        case 'PRODUCT_LIST_NAME':
          $select_column_list .= 'pd.products_name, ';
          break;
        case 'PRODUCT_LIST_MANUFACTURER':
          $select_column_list .= 'm.manufacturers_name, ';
          break;
        case 'PRODUCT_LIST_QUANTITY':
          $select_column_list .= 'p.products_quantity, ';
          break;
        case 'PRODUCT_LIST_IMAGE':
          $select_column_list .= 'p.products_image, ';
          break;
        case 'PRODUCT_LIST_WEIGHT':
          $select_column_list .= 'p.products_weight, ';
          break;
      }
    }
    
	$listing_sql = 	"select distinct 	p.products_id,  
						p.products_quantity,
						p.products_model,
    						p.products_image, 
    						p.products_price, 
    						p.products_date_added, 
						p.products_weight,
    						p.products_tax_class_id, 
    						p.manufacturers_id, 
    						m.manufacturers_name,
    						pd.products_name, 
    						IF(s.status, s.specials_new_products_price, NULL) as specials_new_products_price, 
    						IF(s.status, s.specials_new_products_price, p.products_price) as final_price from " . 
    						TABLE_PRODUCTS_DESCRIPTION . " pd," .
    						TABLE_PRODUCTS . " p left join " . 
    						TABLE_MANUFACTURERS . " m on p.manufacturers_id = m.manufacturers_id left join " . 
    						TABLE_SPECIALS . " s on p.products_id = s.products_id, " . 
    						TABLE_PRODUCTS_TO_CATEGORIES . " p2c 
    						where p.products_status = '1' 
    						and p.products_id = p2c.products_id 
    						and pd.products_id = p2c.products_id 
    						and pd.language_id = '" . (int)$languages_id . "'";
    if (isset($HTTP_GET_VARS['cPath']))
        $listing_sql .= " and p2c.categories_id = '" . (int)$current_category_id . "'";
    if (isset($HTTP_GET_VARS['manufacturers_id']) && tep_not_null($HTTP_GET_VARS['manufacturers_id'])) 
        $listing_sql .= " and m.manufacturers_id = '" . (int)$HTTP_GET_VARS['manufacturers_id'] . "'";
        
    if ( (!isset($HTTP_GET_VARS['sort'])) || (!preg_match('/^[1-8][ad]$/', $HTTP_GET_VARS['sort'])) || (substr($HTTP_GET_VARS['sort'], 0, 1) > sizeof($column_list)) ) {
      for ($i=0, $n=sizeof($column_list); $i<$n; $i++) {
        if ($column_list[$i] == 'PRODUCT_LIST_NAME') {
          $HTTP_GET_VARS['sort'] = $i+1 . 'a';
          $listing_sql .= " order by pd.products_name";
          break;
        }
      }
    } else {
      $sort_col = substr($HTTP_GET_VARS['sort'], 0 , 1);
      $sort_order = substr($HTTP_GET_VARS['sort'], 1);

      switch ($column_list[$sort_col-1]) {
        case 'PRODUCT_LIST_MODEL':
          $listing_sql .= " order by p.products_model " . ($sort_order == 'd' ? 'desc' : '') . ", pd.products_name";
          break;
        case 'PRODUCT_LIST_NAME':
          $listing_sql .= " order by pd.products_name " . ($sort_order == 'd' ? 'desc' : '');
          break;
        case 'PRODUCT_LIST_MANUFACTURER':
          $listing_sql .= " order by m.manufacturers_name " . ($sort_order == 'd' ? 'desc' : '') . ", pd.products_name";
          break;
        case 'PRODUCT_LIST_QUANTITY':
          $listing_sql .= " order by p.products_quantity " . ($sort_order == 'd' ? 'desc' : '') . ", pd.products_name";
          break;
        case 'PRODUCT_LIST_IMAGE':
          $listing_sql .= " order by pd.products_name";
          break;
        case 'PRODUCT_LIST_WEIGHT':
          $listing_sql .= " order by p.products_weight " . ($sort_order == 'd' ? 'desc' : '') . ", pd.products_name";
          break;
        case 'PRODUCT_LIST_PRICE':
          $listing_sql .= " order by final_price " . ($sort_order == 'd' ? 'desc' : '') . ", pd.products_name";
          break;
      }
    }


// calculate category path
$category_depth = 'top';
if (isset($cPath) && tep_not_null($cPath)) {
	$categories_products_query = tep_db_query("select count(*) as total from " . TABLE_PRODUCTS_TO_CATEGORIES . " where categories_id = '" . (int)$current_category_id . "'");
	$cateqories_products = tep_db_fetch_array($categories_products_query);
	if ($cateqories_products['total'] > 0) {
		$category_depth = 'products'; // display products
	} else {
		$category_parent_query = tep_db_query("select count(*) as total from " . TABLE_CATEGORIES . " where parent_id = '" . (int)$current_category_id . "'");
		$category_parent = tep_db_fetch_array($category_parent_query);
		if ($category_parent['total'] > 0) {
			$category_depth = 'nested'; // navigate through the categories
		} else {
			$category_depth = 'products'; // category has no products, but display the 'no products' message
		}
	}
}

$list = array();
$parent_id = (tep_not_null($cPath) == true) ?  (strpos($cPath, '_')?(ltrim(strrchr($cPath, '_' ), '_')):$cPath) : 0;
$categories_query = tep_db_query("select c.categories_id, cd.categories_name, c.categories_image, c.parent_id from " . TABLE_CATEGORIES . " c, " . TABLE_CATEGORIES_DESCRIPTION . " cd where c.parent_id = " . $parent_id . " and c.categories_id = cd.categories_id and cd.language_id='" . (int)$languages_id . $path_cond . "' order by sort_order, cd.categories_name");
while ($categories = tep_db_fetch_array($categories_query))  {
	$list[] = $categories;
}

// check if there are manufacturers
$manufacturers_query = tep_db_query("select manufacturers_id, manufacturers_name from " . TABLE_MANUFACTURERS . " order by manufacturers_name");

// check if there are specials
$specials_count_query = tep_db_query("select count(*) as total from " . TABLE_SPECIALS . " where status = '1'");
$specials_count = tep_db_fetch_array($specials_count_query);

require(DIR_MOBILE_INCLUDES . 'header.php');
require(DIR_WS_LANGUAGES . $language . '/index.php');

?>
<!-- categories //-->
<div id="iphone_content">
<?php
$headerTitle->write($headerTitleText);
echo ((MOBILE_BREADCRUMB_TRAIL == 'true')? '<div id="breadcrumbtrail">' . $breadcrumb->trail('') . '</div>':'');

// BOF manufacturers menu
if ($number_of_rows = tep_db_num_rows($manufacturers_query) && SHOW_MANUFACTURERS_CATALOG_MENU == 'true') {
	?>
	<div class="cms" style="text-align:center">
	<?php
	$manufacturers_array = array();
	if (MAX_MANUFACTURERS_LIST < 2) {
		$manufacturers_array[] = array('id' => '', 'text' => ((isset($HTTP_GET_VARS['manufacturers_id']) && $HTTP_GET_VARS['manufacturers_id'] > 0)? TEXT_MOBILE_BACK_TO_CATEGORIES : PULL_DOWN_DEFAULT));
	}

	while ($manufacturers = tep_db_fetch_array($manufacturers_query)) {
		$manufacturers_name = strip_tags(((strlen($manufacturers['manufacturers_name']) > MAX_DISPLAY_MANUFACTURER_NAME_LEN) ? substr($manufacturers['manufacturers_name'], 0, MAX_DISPLAY_MANUFACTURER_NAME_LEN) . '..' : $manufacturers['manufacturers_name']));		$manufacturers_array[] = array('id' => $manufacturers['manufacturers_id'],
                	                       'text' => $manufacturers_name);
        }

        echo tep_draw_form('manufacturers', tep_mobile_link(FILENAME_CATALOG_MB, '', $request_type, false), 'get') .
             TEXT_MOBILE_MANUFACTURERS . ':<br />' . tep_draw_pull_down_menu('manufacturers_id', $manufacturers_array, (isset($HTTP_GET_VARS['manufacturers_id']) ? $HTTP_GET_VARS['manufacturers_id'] : ''), 'onChange="this.form.submit();" size="' . MAX_MANUFACTURERS_LIST . '" data-theme="a" ') . tep_hide_session_id();
        echo '</form></div>';
}
// EOF manufacturers menu

  if ( !isset($HTTP_GET_VARS['manufacturers_id']) || (isset($HTTP_GET_VARS['manufacturers_id']) && $HTTP_GET_VARS['manufacturers_id'] == '' ) ) {
    if (isset($HTTP_GET_VARS['cPath']) != TRUE) {
        echo '<div class="cms">';
	  if ($specials_count['total'] > 0 ) {
	    echo '  <div class="ui-grid-a ui-responsive">';
	    echo '    <div class="ui-block-a">';
	    echo        tep_button_jquery(TEXT_MOBILE_SPECIALS,tep_mobile_link(FILENAME_SPECIALS),'a','button','data-icon="arrow-r" data-iconpos="right"');
	    echo '    </div>';
	    echo '    <div class="ui-block-b">';
	  }
	  echo tep_button_jquery(TEXT_MOBILE_PRODUCTS_NEW,tep_mobile_link(FILENAME_PRODUCTS_NEW),'a','button','data-icon="arrow-r" data-iconpos="right"');
	  if ($specials_count['total'] > 0 ) {
            echo '    </div>';
            echo '  </div>';
          }
	  echo '</div>';
      }
	
   if (!empty($list)) {	
	?><div class="cms"><?php
	if (CATEGORY_IMAGES_LISTING == 'True') {	
		?><ul data-role="listview" data-inset="true"><?php
		foreach ($list as $item ) {
			$path = tep_mobile_link(FILENAME_CATALOG_MB, tep_get_path($item['categories_id']));
			$img = strlen($item['categories_image']) > 0 ? tep_image(DIR_WS_IMAGES . $item['categories_image'], $item['categories_name']) : tep_image(DIR_MOBILE_IMAGES . 'placeholder_trans.gif') ;
			echo  '<li><a href="' . tep_mobile_link(FILENAME_CATALOG_MB, tep_get_path($item['categories_id'])) . '">' . $img . '<h2 style="margin-top:19px">' . $item['categories_name'] . ((MOBILE_PRODUCT_COUNT == 'true')? '<span class="ui-li-count">' . tep_count_products_in_category($item['categories_id']) . '</span>' : '') . '</h2></a></li>';
		}
		?></ul><?php
	} else {
		foreach ($list as $item ) {
			echo tep_button_jquery($item['categories_name'], tep_mobile_link(FILENAME_CATALOG_MB, tep_get_path($item['categories_id'])),'a','button','data-icon="arrow-r" data-iconpos="right"');
		}
	}
	?></div><?php
   }
}
	if (isset($cateqories_products['total']) && $cateqories_products['total'] > 0 || isset($HTTP_GET_VARS['manufacturers_id'])) {
	  echo '<div class="prodFrame">';
	    switch (MOBILE_PRODUCT_LISTING) {
	      case '0':
	        include(DIR_MOBILE_MODULES . 'products.php');
	      break;
      	      case '1':
		include(DIR_MOBILE_MODULES . 'products_table.php');
              break;
              case '2':
		include(DIR_MOBILE_MODULES . 'products_listview.php');
              break;
          }
	echo '</div>';	
	} else if ($category_depth == 'products') {
		echo '<div class="cms">' . TEXT_NO_PRODUCTS . '</div>';	
	}

	if(sizeof($breadcrumb->_trail) > 1)
	  echo '<div class="bouton">' . tep_button_jquery(IMAGE_BUTTON_BACK_TO . $breadcrumb->_trail[sizeof($breadcrumb->_trail) - 2]['title'], $breadcrumb->_trail[sizeof($breadcrumb->_trail) - 2]['link'],'b','button',' data-icon="back"') . '</div>';

require(DIR_MOBILE_INCLUDES . 'footer.php');
?>
