<?php
/*
  $Id: ht_alternate.php v1.0 20130916 Gergely $

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2013 osCommerce

  Released under the GNU General Public License
*/

  class ht_alternate {
    var $code = 'ht_alternate';
    var $group = 'header_tags';
    var $title;
    var $description;
    var $sort_order;
    var $enabled = false;


   function ht_alternate() {
      $this->title = MODULE_HEADER_TAGS_ALTERNATE_TITLE;
      $this->description = MODULE_HEADER_TAGS_ALTERNATE_DESCRIPTION;

      if ( defined( 'MODULE_HEADER_TAGS_ALTERNATE_STATUS' ) ) {
        $this->sort_order = MODULE_HEADER_TAGS_ALTERNATE_SORT_ORDER;
        $this->enabled = ( MODULE_HEADER_TAGS_ALTERNATE_STATUS == 'True' );
      }
    }

    function execute() {
      global $oscTemplate, $mobile_url, $PHP_SELF;
      //Remove the session ID for alternate tags
      function StripSessionID($url) {
      	      $sidName = tep_session_name();
      	      if (isset($_GET[ $sidName ])) {
      	      	      if (($sid = strpos($url, $_GET[ $sidName ])) !== FALSE) {
      	      	      	      $SidLength = strlen($_GET[ $sidName ]) + strlen( $sidName ) + 2; // to account for the "?" and "="     
      	      	      	      return substr($url , 0, - $SidLength );
      	      	      }
      	      }
      	      return $url;
      }

      if (defined('MOBILE_SITE') && MOBILE_SITE == 'True' && defined('MOBILE_SESSION') && MOBILE_SESSION != 'True') {
      	      if (isset($mobile_url) && file_exists(DIR_FS_MOBILE . basename($PHP_SELF))) {
      	      	      $meta_tag = '<link rel="alternate" media="only screen and (max-width: 640px)" href="' . StripSessionID($mobile_url) . '" />' . "\n" . 
      	      	      		  '<link rel="alternate" media="handheld" href="' . StripSessionID($mobile_url) . '" />';
      	      	      $oscTemplate->addBlock( $meta_tag, $this->group );
      	      }
      }
    }

    function isEnabled() {
      return $this->enabled;
    }

    function check() {
      return defined( 'MODULE_HEADER_TAGS_ALTERNATE_STATUS' );
    }

    function install() {
      tep_db_query( "insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Alternative Mobile Site URL', 'MODULE_HEADER_TAGS_ALTERNATE_STATUS', 'True', 'Do you want to add alternate mobile reference to shop?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())" );
      tep_db_query( "insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_HEADER_TAGS_ALTERNATE_SORT_ORDER', '200', 'Sort order of display. Lowest is displayed first.', '6', '2', now())" );
    }

    function remove() {
      tep_db_query( "delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      $keys_array = array();

      $keys_array[] = 'MODULE_HEADER_TAGS_ALTERNATE_STATUS';
      $keys_array[] = 'MODULE_HEADER_TAGS_ALTERNATE_SORT_ORDER';

      return $keys_array;
    }
  }
?>
