<?php
/*
  $Id: ht_apple_touch.php v1.0 20130202 Gergely $

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2013 osCommerce

  Released under the GNU General Public License
*/

  class ht_apple_touch {
    var $code = 'ht_apple_touch';
    var $group = 'header_tags';
    var $title;
    var $description;
    var $sort_order;
    var $enabled = false;

    function ht_apple_touch() {
      $this->title = MODULE_HEADER_TAGS_APPLE_TOUCH_TITLE;
      $this->description = MODULE_HEADER_TAGS_APPLE_TOUCH_DESCRIPTION;

      if ( defined( 'MODULE_HEADER_TAGS_APPLE_TOUCH_STATUS' ) ) {
        $this->sort_order = MODULE_HEADER_TAGS_APPLE_TOUCH_SORT_ORDER;
        $this->enabled = ( MODULE_HEADER_TAGS_APPLE_TOUCH_STATUS == 'True' );
      }
    }

    function execute() {
      global $oscTemplate;

      $user_agent = getenv('HTTP_USER_AGENT');
      if (preg_match('/Safari/i', $user_agent)) {
        $meta_tag =  '<link rel="apple-touch-icon';
        if (MODULE_HEADER_TAGS_APPLE_TOUCH_ICON_SELECT == 'Precomposed') {
          $meta_tag .= '-precomposed';
        }
        $meta_tag .= '" href="'.DIR_MOBILE_IMAGES . MODULE_HEADER_TAGS_APPLE_TOUCH_ICON_FILE.'" />';

        $oscTemplate->addBlock( $meta_tag, $this->group );
      }
    }

    function isEnabled() {
      return $this->enabled;
    }

    function check() {
      return defined( 'MODULE_HEADER_TAGS_APPLE_TOUCH_STATUS' );
    }

    function install() {
      tep_db_query( "insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Apple Safari Icons', 'MODULE_HEADER_TAGS_APPLE_TOUCH_STATUS', 'True', 'Do you want to add a Apple Safari icon to shop?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())" );
      tep_db_query( "insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_HEADER_TAGS_APPLE_TOUCH_SORT_ORDER', '200', 'Sort order of display. Lowest is displayed first.', '6', '2', now())" );
      tep_db_query( "insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Apple icon file', 'MODULE_HEADER_TAGS_APPLE_TOUCH_ICON_FILE', 'apple-touch-icon.png', 'Insert the Apple icon file name. File must be placed in the directory: mobile/images/.', '6', '3', now())" );
      tep_db_query( "insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Select icon type', 'MODULE_HEADER_TAGS_APPLE_TOUCH_ICON_SELECT', 'Standard', 'Insert the precomposed icon file name.', '6', '4', 'tep_cfg_select_option(array(\'Standard\', \'Precomposed\'), ', now())" );
    }

    function remove() {
      tep_db_query( "delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      $keys_array = array();

      $keys_array[] = 'MODULE_HEADER_TAGS_APPLE_TOUCH_STATUS';
      $keys_array[] = 'MODULE_HEADER_TAGS_APPLE_TOUCH_SORT_ORDER';
      $keys_array[] = 'MODULE_HEADER_TAGS_APPLE_TOUCH_ICON_FILE';
      $keys_array[] = 'MODULE_HEADER_TAGS_APPLE_TOUCH_ICON_SELECT';

      return $keys_array;
    }
  }
  
  ////
  // Function to prevent boxes showing for the output-only test functions
  if( !function_exists( 'tep_cfg_do_nothing' ) ) {
    function tep_cfg_do_nothing() {
      return '';
    }
  }
?>
