<?php
/*
  $Id$

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2012 osCommerce

  Released under the GNU General Public License
*/

  class ht_canonical {
    var $code = 'ht_canonical';
    var $group = 'header_tags';
    var $title;
    var $description;
    var $sort_order;
    var $enabled = false;

    function ht_canonical() {
      $this->title = MODULE_HEADER_TAGS_CANONICAL_TITLE;
      $this->description = MODULE_HEADER_TAGS_CANONICAL_DESCRIPTION;

      if ( defined('MODULE_HEADER_TAGS_CANONICAL_STATUS') ) {
        $this->sort_order = MODULE_HEADER_TAGS_CANONICAL_SORT_ORDER;
        $this->enabled = (MODULE_HEADER_TAGS_CANONICAL_STATUS == 'True');
      }
    }

    function execute() {
      global $PHP_SELF, $HTTP_GET_VARS, $cPath, $oscTemplate, $classic_site, $request_type;
      //Remove the session ID for canonical tags
      function StripSessionIDcan($url) {
      	      $sidName = tep_session_name();
      	      if (isset($_GET[ $sidName ])) {
      	      	      if (($sid = strpos($url, $_GET[ $sidName ])) !== FALSE) {
      	      	      	      $SidLength = strlen($_GET[ $sidName ]) + strlen( $sidName ) + 2; // to account for the "?" and "="     
      	      	      	      return substr($url , 0, - $SidLength );
      	      	      }
      	      }
      	      return $url;
      }

      if (defined('MOBILE_SITE') && MOBILE_SITE == 'True' && defined('MOBILE_SESSION') && MOBILE_SESSION == 'True') {
        //mobile store
        if(isset($classic_site)) {
          $canonical_link = StripSessionIDcan($classic_site);
	} else {
	  $canonical_link_replace_from = array('%' . DIR_WS_HTTP_MOBILE .'%', '/-mp-/', '/-mc-/', '/-mm-/', '/-mpr-/', '/-mpri-/', '/-mpi-/', '/-ma-/', '/-mau-/', '/-mby-/', '/-mf-/', '/-mfc-/', '/-mfri-/', '/-mfra-/', '/-mi-/', '/-mlinks-/', '/-mn-/', '/-mnc-/', '/-mnri-/', '/-mnra-/', '/-mpm-/', '/-mpo-/', '/-mt-/');
	  $canonical_link_replace_to = array(DIR_WS_HTTP_CATALOG, '-p-', '-c-', '-m-', '-pr-', '-pri-', '-pi-', '-a-', '-au-', '-by-', '-f-', '-fc-', '-fri-', '-fra-', '-i-', '-links-', '-n-', '-nc-', '-nri-', '-nra-', '-pm-', '-po-', '-t-');
          $canonical_link = (($request_type == 'SSL') ? HTTPS_SERVER : HTTP_SERVER) . preg_replace($canonical_link_replace_from, $canonical_link_replace_to, StripSessionIDcan(htmlspecialchars($_SERVER['REQUEST_URI'])));
	}
        $oscTemplate->addBlock('<link rel="canonical" href="' . $canonical_link . '" />' . "\n", $this->group);
      } elseif (MOBILE_SITE != 'True') {
        //main store
        if (basename($PHP_SELF) == FILENAME_PRODUCT_INFO) {
          $oscTemplate->addBlock('<link rel="canonical" href="' . tep_href_link(FILENAME_PRODUCT_INFO, 'products_id=' . (int)$HTTP_GET_VARS['products_id'], 'NONSSL', false) . '" />' . "\n", $this->group);
        } elseif (basename($PHP_SELF) == FILENAME_DEFAULT) {
          if (isset($cPath) && tep_not_null($cPath)) {
            $oscTemplate->addBlock('<link rel="canonical" href="' . tep_href_link(FILENAME_DEFAULT, 'cPath=' . $cPath, 'NONSSL', false) . '" />' . "\n", $this->group);
          } elseif (isset($HTTP_GET_VARS['manufacturers_id']) && tep_not_null($HTTP_GET_VARS['manufacturers_id'])) {
            $oscTemplate->addBlock('<link rel="canonical" href="' . tep_href_link(FILENAME_DEFAULT, 'manufacturers_id=' . (int)$HTTP_GET_VARS['manufacturers_id'], 'NONSSL', false) . '" />' . "\n", $this->group);
          }
        }
      }
    }

    function isEnabled() {
      return $this->enabled;
    }

    function check() {
      return defined('MODULE_HEADER_TAGS_CANONICAL_STATUS');
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Canonical Module', 'MODULE_HEADER_TAGS_CANONICAL_STATUS', 'True', 'Do you want to enable the Canonical module?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_HEADER_TAGS_CANONICAL_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_HEADER_TAGS_CANONICAL_STATUS', 'MODULE_HEADER_TAGS_CANONICAL_SORT_ORDER');
    }
  }
?>
